expect = require('expect.js');
var jsc = require('./index');
require = jsc.mock(module);
var testCase = require('./test_case.js',true);

describe("jscoverage",function(){
    it('_reset()',function(){
      testCase._reset('conn');
      var conn = testCase._get('conn');
      var res = conn({})
      expect(res).to.be('conn');
    });
  describe("#_replace()",function(){
    it('_replace function',function(){
      testCase._replace('conn',function(cfg){
        return db.close(cfg);
      });
      var res = testCase._call('conn',[{}]);
      expect(res).to.be('close');
    });
    it('_replace object',function(){
      testCase._replace('conn',{a:1,b:2,c:function(){return 'abc'}});
      var obj = testCase._get('conn');
      expect(obj.c()).to.be('abc');
    });
    it('_replace array',function(){
      testCase._replace('conn',[1,2,{a:1,b:2,c:function(){return 'abc'}}]);
      var obj = testCase._get('conn');
      expect(obj[2].c()).to.be('abc');
    });
    it('_replace complex',function(){
      testCase._replace('conn',[function(){return 1},1,2,{a:1,b:2,c:function(){return 'abc'}}]);
      var obj = testCase._get('conn');
      expect(obj[0]()).to.be(1);
    });
  });
    it('_reset()',function(){
      testCase._reset('conn');
      var conn = testCase._get('conn');
      var res = conn({})
      expect(res).to.be('conn');
    });
});

process.on('exit',function(){
  jsc.coverage();
  jsc.coverageDetail();
});
